package dev.shadowsoffire.apotheosis.adventure.loot;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import com.mojang.datafixers.kinds.App;
import com.mojang.datafixers.kinds.Applicative;
import com.mojang.datafixers.util.Function3;
import com.mojang.serialization.Codec;
import com.mojang.serialization.codecs.RecordCodecBuilder;
import dev.shadowsoffire.apotheosis.adventure.AdventureModule;
import dev.shadowsoffire.apotheosis.adventure.affix.Affix;
import dev.shadowsoffire.apotheosis.adventure.affix.AffixType;
import dev.shadowsoffire.apotheosis.adventure.loot.LootController;
import dev.shadowsoffire.apotheosis.adventure.loot.LootRarity;
import dev.shadowsoffire.apotheosis.adventure.loot.RarityRegistry;
import dev.shadowsoffire.placebo.codec.CodecProvider;
import dev.shadowsoffire.placebo.codec.PlaceboCodecs;
import dev.shadowsoffire.placebo.reload.DynamicHolder;
import java.util.Collections;
import java.util.List;
import java.util.Optional;
import java.util.Random;
import java.util.Set;
import javax.annotation.Nullable;
import net.minecraft.util.ExtraCodecs;
import net.minecraft.util.RandomSource;
import net.minecraft.world.item.ItemStack;
import net.minecraftforge.registries.ForgeRegistries;
import org.apache.commons.lang3.mutable.MutableInt;

public final class LootRule extends Record {
  private final AffixType type;
  
  private final float chance;
  
  @Nullable
  private final LootRule backup;
  
  public static final Codec<LootRule> CODEC;
  
  public LootRule(AffixType type, float chance, @Nullable LootRule backup) {
    this.type = type;
    this.chance = chance;
    this.backup = backup;
  }
  
  public final String toString() {
    // Byte code:
    //   0: aload_0
    //   1: <illegal opcode> toString : (Ldev/shadowsoffire/apotheosis/adventure/loot/LootRarity$LootRule;)Ljava/lang/String;
    //   6: areturn
    // Line number table:
    //   Java source line number -> byte code offset
    //   #180	-> 0
    // Local variable table:
    //   start	length	slot	name	descriptor
    //   0	7	0	this	Ldev/shadowsoffire/apotheosis/adventure/loot/LootRarity$LootRule;
  }
  
  public final int hashCode() {
    // Byte code:
    //   0: aload_0
    //   1: <illegal opcode> hashCode : (Ldev/shadowsoffire/apotheosis/adventure/loot/LootRarity$LootRule;)I
    //   6: ireturn
    // Line number table:
    //   Java source line number -> byte code offset
    //   #180	-> 0
    // Local variable table:
    //   start	length	slot	name	descriptor
    //   0	7	0	this	Ldev/shadowsoffire/apotheosis/adventure/loot/LootRarity$LootRule;
  }
  
  public final boolean equals(Object o) {
    // Byte code:
    //   0: aload_0
    //   1: aload_1
    //   2: <illegal opcode> equals : (Ldev/shadowsoffire/apotheosis/adventure/loot/LootRarity$LootRule;Ljava/lang/Object;)Z
    //   7: ireturn
    // Line number table:
    //   Java source line number -> byte code offset
    //   #180	-> 0
    // Local variable table:
    //   start	length	slot	name	descriptor
    //   0	8	0	this	Ldev/shadowsoffire/apotheosis/adventure/loot/LootRarity$LootRule;
    //   0	8	1	o	Ljava/lang/Object;
  }
  
  public AffixType type() {
    return this.type;
  }
  
  public float chance() {
    return this.chance;
  }
  
  @Nullable
  public LootRule backup() {
    return this.backup;
  }
  
  static {
    CODEC = RecordCodecBuilder.create(inst -> inst.group((App)PlaceboCodecs.enumCodec(AffixType.class).fieldOf("type").forGetter(LootRule::type), (App)Codec.FLOAT.fieldOf("chance").forGetter(LootRule::chance), (App)PlaceboCodecs.nullableField(ExtraCodecs.m_184415_(()), "backup").forGetter(())).apply((Applicative)inst, dev.shadowsoffire.apotheosis.adventure.loot.LootRarity.LootRule::new));
  }
  
  private static Random jRand = new Random();
  
  public LootRule(AffixType type, float chance) {
    this(type, chance, Optional.empty());
  }
  
  public LootRule(AffixType type, float chance, Optional<LootRule> backup) {
    this(type, chance, backup.orElse(null));
  }
  
  public void execute(ItemStack stack, LootRarity rarity, Set<DynamicHolder<? extends Affix>> currentAffixes, MutableInt sockets, RandomSource rand) {
    if (this.type == AffixType.DURABILITY)
      return; 
    if (rand.m_188501_() <= this.chance) {
      if (this.type == AffixType.SOCKET) {
        sockets.add(1);
        return;
      } 
      List<DynamicHolder<? extends Affix>> available = LootController.getAvailableAffixes(stack, rarity, currentAffixes, this.type);
      if (available.size() == 0) {
        if (this.backup != null) {
          this.backup.execute(stack, rarity, currentAffixes, sockets, rand);
        } else {
          AdventureModule.LOGGER.error("Failed to execute LootRule {}/{}/{}/{}!", ForgeRegistries.ITEMS.getKey(stack.m_41720_()), RarityRegistry.INSTANCE.getKey((CodecProvider)rarity), this.type, Float.valueOf(this.chance));
        } 
        return;
      } 
      jRand.setSeed(rand.m_188505_());
      Collections.shuffle(available, jRand);
      currentAffixes.add(available.get(0));
    } 
  }
}
